﻿@{
    ViewBag.Title = "webupload";
    Layout = "~/Views/Shared/_B3Layout.cshtml";
}
@section HeadCss{
    @if (false)
    {
        <link href="/Content/public/bootstrap3/bootstrap.css" rel="stylesheet" type="text/css" />
    }
    <link href="../../Scripts/Plugins/webuploader/webuploader.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .filedelete
        {
            height: 90px;
        }
    </style>
}
@section Scripts{
    @if (false)
    {
        <script src="../../Scripts/Public/jquery-1.11.1.js" type="text/javascript"></script>
        <script src="../../Scripts/Public/bootstrap3/bootstrap.js" type="text/javascript"></script>
        <script src="../../Scripts/Public/sa/jquery.sa.ajax.js" type="text/javascript"></script>
    }
    <script src="../../Scripts/Plugins/webuploader/webuploader.js" type="text/javascript"></script>
    <script type="text/jscript">
        var $ = jQuery;
        var $list = $('#thelist');
        var $btn = $('#ctlBtn');
        var state = 'pending';
        var uploader = WebUploader.create({

            // swf文件路径
            swf: '/Scripts/Plugins/webuploader/Uploader.swf',

            // 文件接收服务端。
            server: '/file/UploadFile',

            // 选择文件的按钮。可选。
            // 内部根据当前运行是创建，可能是input元素，也可能是flash.
            pick: '#picker',

            // 不压缩image, 默认如果是jpeg，文件上传前会压缩一把再上传！
            resize: false
            , runtimeOrder: 'flash'

        });

        // 当有文件被添加进队列的时候
        uploader.on('fileQueued', function (file) {
            var fileQueuedHtml = '<div id="' + file.id + '" class="list-group-item list-group-item-info row">';
            fileQueuedHtml += '<div class="col-lg-10 col-md-10 col-sm-9 col-xs-12 fileinfo" >';
            fileQueuedHtml += '<span class="info h4">' + file.name + '</span>';
            fileQueuedHtml += '<h6 class="text-muted">' + WebUploader.formatSize(file.size) + '</h6>'; 
            fileQueuedHtml += '<span class="state h5">等待上传...</span>';
            fileQueuedHtml += '</div>';
            fileQueuedHtml += '<div class="col-lg-2 col-md-2 col-sm-3 col-xs-12 ">';

            fileQueuedHtml += '<button class ="btn btn-danger btn-block  btn-lg filedelete" >移除</button>';

            fileQueuedHtml += '</div>';
            fileQueuedHtml += '</div>'
            $list.append(fileQueuedHtml);
        });

        $(document).ready(function () {
            $(document).on("click", ".filedelete", function () {
                var fileid = $(this).parent().parent().attr("id");
                var file = uploader.getFile(fileid);
                uploader.removeFile(file);
            });
            //获取pick按钮设置占整行（调试得知）
            $("#uploader").find(".webuploader-pick").addClass("btn-lg btn-block");

        });


        // 当有文件被移除进队列的时候
        uploader.on('fileDequeued', function (file) {
            $("#" + file.id).remove();
        });

        // 文件上传过程中创建进度条实时显示。
        uploader.on('uploadProgress', function (file, percentage) {
            var $li = $('#' + file.id).find(".fileinfo");
            $percent = $li.find('.progress .progress-bar');

            // 避免重复创建
            if (!$percent.length) {
                $percent = $('<div class="progress">' + '<div class="progress-bar  progress-bar-success" role="progressbar"   style="width: 100%">0%' + '</div>' + '</div>').appendTo($li).find('.progress-bar');
            }

            $li.find('.state').text('上传中...');

            $percent.css('width', Math.round(percentage * 100) + '%');
            $percent.text(Math.round(percentage * 100) + '%');

        });
        uploader.on('uploadSuccess', function (file, ret) {
            if (ret.result == "success") {
                $('#' + file.id).find('.state').text('已上传！');
                $('#' + file.id).find('.state').addClass("text-success");
                $('#' + file.id).find('.filedelete').hide();
            }
            else {
                alert(ret.msg);
            }
        });

        uploader.on('uploadError', function (file) {
            $('#' + file.id).find('.state').text('上传出错！');
        });

        uploader.on('uploadComplete', function (file) {
            $('#' + file.id).find('.progress').fadeOut();
        });


        uploader.on('all', function (type) {
            if (type === 'startUpload') {
                state = 'uploading';
            } else if (type === 'stopUpload') {
                state = 'paused';
            } else if (type === 'uploadFinished') {
                state = 'done';
            }

            if (state === 'uploading') {
                $btn.html('<span class="glyphicon glyphicon-pause"></span>暂停上传');
            } else {
                $btn.html(' <span class="glyphicon glyphicon-open"></span>开始上传');
            }
        });

        $btn.bind('click', function () {
            if (state === 'uploading') {
                uploader.stop(true);
            } else {
                uploader.upload();
            }
        });

        function GetFiles() {
            return uploader.getFiles('complete');
        }
 

    </script>
}
<div id="uploader" class="wu-example">
    <!--用来存放文件信息-->
    <div id="thelist" class="list-group container-fluid">
    </div>
    <div id="picker" class="">
        <span class="glyphicon glyphicon-file"></span>选择文件
    </div>
    <button id="ctlBtn" class="btn  btn-lg btn-success btn-block">
        <span class="glyphicon glyphicon-open"></span>开始上传
    </button>
</div>
